import { Context, Pda, PublicKey, Signer } from '@metaplex-foundation/umi';
import { WithWritable } from '../generated';
export declare const resolveTreasuryTokenWhenMint: (context: Pick<Context, 'eddsa' | 'programs'>, accounts: {
    mint: WithWritable<PublicKey | Pda>;
    authority: WithWritable<Signer>;
}, args: any, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveSystemProgramWhenMint: (context: Pick<Context, 'programs'>, accounts: {
    mint: WithWritable<PublicKey | Pda>;
}, args: any, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveSplTokenProgramWhenMint: (context: Pick<Context, 'programs'>, accounts: {
    mint: WithWritable<PublicKey | Pda>;
}, args: any, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveSplAtaProgramWhenMint: (context: Pick<Context, 'programs'>, accounts: {
    mint: WithWritable<PublicKey | Pda>;
}, args: any, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveOwnerTokenWhenMint: (context: Pick<Context, 'eddsa' | 'programs'>, accounts: {
    mint: WithWritable<PublicKey | Pda>;
    owner: WithWritable<Signer | PublicKey | Pda>;
}, args: any, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveTicketTokenWhenMint: (context: Pick<Context, 'eddsa' | 'programs'>, accounts: {
    mint: WithWritable<PublicKey | Pda>;
    ticket: WithWritable<PublicKey | Pda>;
}, args: any, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveOwnerTokenWhenMintArg: (context: Pick<Context, 'eddsa' | 'programs'>, accounts: {
    owner: WithWritable<Signer | PublicKey | Pda>;
}, args: {
    mint: PublicKey | Pda;
}, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
export declare const resolveTicketTokenWhenMintArg: (context: Pick<Context, 'eddsa' | 'programs'>, accounts: {
    ticket: WithWritable<PublicKey | Pda>;
}, args: {
    mint: PublicKey | Pda;
}, programId: PublicKey, isWritable: boolean) => WithWritable<PublicKey<string> | Pda<string, number>>;
