"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveTicketTokenWhenMintArg = exports.resolveOwnerTokenWhenMintArg = exports.resolveTicketTokenWhenMint = exports.resolveOwnerTokenWhenMint = exports.resolveSplAtaProgramWhenMint = exports.resolveSplTokenProgramWhenMint = exports.resolveSystemProgramWhenMint = exports.resolveTreasuryTokenWhenMint = void 0;
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const umi_1 = require("@metaplex-foundation/umi");
const resolveTreasuryTokenWhenMint = (context, accounts, args, programId, isWritable) => accounts.mint[0] === programId
    ? [programId, false]
    : [
        (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
            owner: (0, umi_1.publicKey)(accounts.authority[0]),
            mint: (0, umi_1.publicKey)(accounts.mint[0]),
        }),
        isWritable,
    ];
exports.resolveTreasuryTokenWhenMint = resolveTreasuryTokenWhenMint;
const resolveSystemProgramWhenMint = (context, accounts, args, programId, isWritable) => accounts.mint[0] === programId
    ? [programId, false]
    : [
        context.programs.getPublicKey('systemProgram', '11111111111111111111111111111111'),
        isWritable,
    ];
exports.resolveSystemProgramWhenMint = resolveSystemProgramWhenMint;
const resolveSplTokenProgramWhenMint = (context, accounts, args, programId, isWritable) => accounts.mint[0] === programId
    ? [programId, false]
    : [
        context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable,
    ];
exports.resolveSplTokenProgramWhenMint = resolveSplTokenProgramWhenMint;
const resolveSplAtaProgramWhenMint = (context, accounts, args, programId, isWritable) => accounts.mint[0] === programId
    ? [programId, false]
    : [
        context.programs.getPublicKey('splAssociatedToken', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL'),
        isWritable,
    ];
exports.resolveSplAtaProgramWhenMint = resolveSplAtaProgramWhenMint;
const resolveOwnerTokenWhenMint = (context, accounts, args, programId, isWritable) => accounts.mint[0] === programId
    ? [programId, false]
    : [
        (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
            owner: (0, umi_1.publicKey)(accounts.owner[0]),
            mint: (0, umi_1.publicKey)(accounts.mint[0]),
        }),
        isWritable,
    ];
exports.resolveOwnerTokenWhenMint = resolveOwnerTokenWhenMint;
const resolveTicketTokenWhenMint = (context, accounts, args, programId, isWritable) => accounts.mint[0] === programId
    ? [programId, false]
    : [
        (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
            owner: (0, umi_1.publicKey)(accounts.ticket[0]),
            mint: (0, umi_1.publicKey)(accounts.mint[0]),
        }),
        isWritable,
    ];
exports.resolveTicketTokenWhenMint = resolveTicketTokenWhenMint;
const resolveOwnerTokenWhenMintArg = (context, accounts, args, programId, isWritable) => [
    (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
        owner: (0, umi_1.publicKey)(accounts.owner[0]),
        mint: (0, umi_1.publicKey)(args.mint),
    }),
    isWritable,
];
exports.resolveOwnerTokenWhenMintArg = resolveOwnerTokenWhenMintArg;
const resolveTicketTokenWhenMintArg = (context, accounts, args, programId, isWritable) => [
    (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
        owner: (0, umi_1.publicKey)(accounts.ticket[0]),
        mint: (0, umi_1.publicKey)(args.mint),
    }),
    isWritable,
];
exports.resolveTicketTokenWhenMintArg = resolveTicketTokenWhenMintArg;
//# sourceMappingURL=resolver.js.map